unit AppDelegateU;

{$modeswitch ObjectiveC2}

interface

uses
  SysUtils, Foundation, AppKit, Mapbox, ViewControllerU;

type
  AppDelegate = objcclass(NSObject, NSApplicationDelegateProtocol)
    procedure applicationDidFinishLaunching(notification : NSNotification); message 'applicationDidFinishLaunching:';
    procedure applicationWillTerminate(notification : NSNotification); message 'applicationWillTerminate:';
    procedure dealloc; override;

     {IBActions}
    procedure displayAboutBox(sender : id); message 'displayAboutBox:';
  end;
  

implementation

procedure AppDelegate.applicationDidFinishLaunching(notification : NSNotification);
begin
end;

procedure AppDelegate.applicationWillTerminate(notification : NSNotification);
begin
end;

procedure AppDelegate.dealloc;
begin
  inherited dealloc;
end;

procedure AppDelegate.displayAboutBox(sender : id);
var
  creditsHtml : NSString;
begin
  creditsHtml :=
   NSSTR('<html><font face="Helvetica Neue"><center>' +
         'Powered by <a href="https://mapbox.github.io/mapbox-gl-native/macos">Mapbox</a>' +
         ', version ' + IntToStr(Round(MapboxVersionNumber)) + '<br><br>' +
         'Weather forecast data retrieved by<br>' +
         '<a href="https://macpgmr.github.io/MacXPlatform/PascalDynLibs_2.html">NDFD</a>' +
         ', version ' + Ndfd.GetLibVersion + '<br><br>' +
         'Double-click anywhere in the U.S.<br>to see today''s forecast.' +
         '</center></html>');

  NSApp.orderFrontStandardAboutPanelWithOptions(
   NSDictionary.dictionaryWithObject_forKey(
    NSAttributedString.alloc.initWithHTML_documentAttributes(
     creditsHtml.dataUsingEncoding(NSUTF8StringEncoding), nil),
    NSSTR('Credits')));
end;

end.
