{ Parsed from Mapbox.framework MGLFeature.h }

{$ifdef TYPES}
type
  MGLPointFeaturePtr = ^MGLPointFeature;
  MGLPolylineFeaturePtr = ^MGLPolylineFeature;
  MGLPolygonFeaturePtr = ^MGLPolygonFeature;
  MGLPointCollectionFeaturePtr = ^MGLPointCollectionFeature;
  MGLMultiPolylineFeaturePtr = ^MGLMultiPolylineFeature;
  MGLMultiPolygonFeaturePtr = ^MGLMultiPolygonFeature;
  MGLShapeCollectionFeaturePtr = ^MGLShapeCollectionFeature;
  MGLFeatureProtocolPtr = ^MGLFeatureProtocol;
{$endif}

{$ifdef PROTOCOLS}

type
  MGLFeatureProtocol = objcprotocol external name 'MGLFeature' (MGLAnnotationProtocol)
    procedure setIdentifier(newValue: id); message 'setIdentifier:';
    function identifier: id; message 'identifier';
    procedure setAttributes(newValue: NSDictionary); message 'setAttributes:';
    function attributes: NSDictionary; message 'attributes';
    function attributeForKey (key: NSString): id; message 'attributeForKey:';
    function geoJSONDictionary: NSDictionary; message 'geoJSONDictionary';
  end;
{$endif}

{$ifdef CLASSES}

type
  MGLPointFeature = objcclass external (MGLPointAnnotation, MGLFeatureProtocol)

    { Adopted protocols }
    function attributeForKey (key: NSString): id; message 'attributeForKey:';
    procedure setAttributes(newValue: NSDictionary); message 'setAttributes:';
    function attributes: NSDictionary; message 'attributes';
    function geoJSONDictionary: NSDictionary; message 'geoJSONDictionary';
    procedure setIdentifier(newValue: id); message 'setIdentifier:';
    function identifier: id; message 'identifier';
  end;

type
  MGLPolylineFeature = objcclass external (MGLPolyline, MGLFeatureProtocol)

    { Adopted protocols }
    function attributeForKey (key: NSString): id; message 'attributeForKey:';
    procedure setAttributes(newValue: NSDictionary); message 'setAttributes:';
    function attributes: NSDictionary; message 'attributes';
    function geoJSONDictionary: NSDictionary; message 'geoJSONDictionary';
    procedure setIdentifier(newValue: id); message 'setIdentifier:';
    function identifier: id; message 'identifier';
  end;

type
  MGLPolygonFeature = objcclass external (MGLPolygon, MGLFeatureProtocol)

    { Adopted protocols }
    function attributeForKey (key: NSString): id; message 'attributeForKey:';
    procedure setAttributes(newValue: NSDictionary); message 'setAttributes:';
    function attributes: NSDictionary; message 'attributes';
    function geoJSONDictionary: NSDictionary; message 'geoJSONDictionary';
    procedure setIdentifier(newValue: id); message 'setIdentifier:';
    function identifier: id; message 'identifier';
  end;

type
  MGLPointCollectionFeature = objcclass external (MGLPointCollection, MGLFeatureProtocol)

    { Adopted protocols }
    function attributeForKey (key: NSString): id; message 'attributeForKey:';
    procedure setAttributes(newValue: NSDictionary); message 'setAttributes:';
    function attributes: NSDictionary; message 'attributes';
    function geoJSONDictionary: NSDictionary; message 'geoJSONDictionary';
    procedure setIdentifier(newValue: id); message 'setIdentifier:';
    function identifier: id; message 'identifier';
  end;

type
  MGLMultiPolylineFeature = objcclass external (MGLMultiPolyline, MGLFeatureProtocol)

    { Adopted protocols }
    function attributeForKey (key: NSString): id; message 'attributeForKey:';
    procedure setAttributes(newValue: NSDictionary); message 'setAttributes:';
    function attributes: NSDictionary; message 'attributes';
    function geoJSONDictionary: NSDictionary; message 'geoJSONDictionary';
    procedure setIdentifier(newValue: id); message 'setIdentifier:';
    function identifier: id; message 'identifier';
  end;

type
  MGLMultiPolygonFeature = objcclass external (MGLMultiPolygon, MGLFeatureProtocol)

    { Adopted protocols }
    function attributeForKey (key: NSString): id; message 'attributeForKey:';
    procedure setAttributes(newValue: NSDictionary); message 'setAttributes:';
    function attributes: NSDictionary; message 'attributes';
    function geoJSONDictionary: NSDictionary; message 'geoJSONDictionary';
    procedure setIdentifier(newValue: id); message 'setIdentifier:';
    function identifier: id; message 'identifier';
  end;

type
  MGLShapeCollectionFeature = objcclass external (MGLShapeCollection, MGLFeatureProtocol)
  public
    function shapes: NSArray; message 'shapes';
    class function shapeCollectionWithShapes (shapes_: NSArray): instancetype; message 'shapeCollectionWithShapes:';

    { Adopted protocols }
    function attributeForKey (key: NSString): id; message 'attributeForKey:';
    procedure setAttributes(newValue: NSDictionary); message 'setAttributes:';
    function attributes: NSDictionary; message 'attributes';
    function geoJSONDictionary: NSDictionary; message 'geoJSONDictionary';
    procedure setIdentifier(newValue: id); message 'setIdentifier:';
    function identifier: id; message 'identifier';
  end;
{$endif}

