{ Parsed from Mapbox.framework MGLLineStyleLayer.h }

{ Types from MGLLineStyleLayer }
{$ifdef TYPES}


{$endif}


{$ifdef TYPES}
type
  MGLLineStyleLayerPtr = ^MGLLineStyleLayer;
{$endif}

{$ifdef TYPES}
type
  MGLLineCap = NSUInteger;
  MGLLineCapPtr = ^MGLLineCap;

const
  MGLLineCapButt = 0;
  MGLLineCapRound = 1;
  MGLLineCapSquare = 2;

type
  MGLLineJoin = NSUInteger;
  MGLLineJoinPtr = ^MGLLineJoin;

const
  MGLLineJoinBevel = 0;
  MGLLineJoinRound = 1;
  MGLLineJoinMiter = 2;

type
  MGLLineTranslationAnchor = NSUInteger;
  MGLLineTranslationAnchorPtr = ^MGLLineTranslationAnchor;

const
  MGLLineTranslationAnchorMap = 0;
  MGLLineTranslationAnchorViewport = 1;
{$endif}

{$ifdef CLASSES}

type
  MGLLineStyleLayer = objcclass external (MGLVectorStyleLayer)
  public
    function initWithIdentifier_source (identifier_: NSString; source: MGLSource): instancetype; message 'initWithIdentifier:source:';
    procedure setLineCap(newValue: MGLStyleValue); message 'setLineCap:';
    function lineCap: MGLStyleValue; message 'lineCap';
    procedure setLineJoin(newValue: MGLStyleValue); message 'setLineJoin:';
    function lineJoin: MGLStyleValue; message 'lineJoin';
    procedure setLineMiterLimit(newValue: MGLStyleValue); message 'setLineMiterLimit:';
    function lineMiterLimit: MGLStyleValue; message 'lineMiterLimit';
    procedure setLineRoundLimit(newValue: MGLStyleValue); message 'setLineRoundLimit:';
    function lineRoundLimit: MGLStyleValue; message 'lineRoundLimit';
    procedure setLineBlur(newValue: MGLStyleValue); message 'setLineBlur:';
    function lineBlur: MGLStyleValue; message 'lineBlur';
    procedure setLineBlurTransition(newValue: MGLTransition); message 'setLineBlurTransition:';
    function lineBlurTransition: MGLTransition; message 'lineBlurTransition';
    {$if defined(TARGET_OS_IPHONE)}
    procedure setLineColor(newValue: UIColor *ProtocolPtr); message 'setLineColor:';
    function lineColor: UIColor *ProtocolPtr; message 'lineColor';
    {$else}
    procedure setLineColor_(newValue: MGLStyleValue); message 'setLineColor:';
    function lineColor_: MGLStyleValue; message 'lineColor';
    {$endif}
    procedure setLineColorTransition(newValue: MGLTransition); message 'setLineColorTransition:';
    function lineColorTransition: MGLTransition; message 'lineColorTransition';
    procedure setLineDashPattern(newValue: MGLStyleValue); message 'setLineDashPattern:';
    function lineDashPattern: MGLStyleValue; message 'lineDashPattern';
    procedure setLineDashPatternTransition(newValue: MGLTransition); message 'setLineDashPatternTransition:';
    function lineDashPatternTransition: MGLTransition; message 'lineDashPatternTransition';
    procedure setLineDasharray(newValue: MGLStyleValue); message 'setLineDasharray:';
    function lineDasharray: MGLStyleValue; message 'lineDasharray';
    procedure setLineGapWidth(newValue: MGLStyleValue); message 'setLineGapWidth:';
    function lineGapWidth: MGLStyleValue; message 'lineGapWidth';
    procedure setLineGapWidthTransition(newValue: MGLTransition); message 'setLineGapWidthTransition:';
    function lineGapWidthTransition: MGLTransition; message 'lineGapWidthTransition';
    procedure setLineOffset(newValue: MGLStyleValue); message 'setLineOffset:';
    function lineOffset: MGLStyleValue; message 'lineOffset';
    procedure setLineOffsetTransition(newValue: MGLTransition); message 'setLineOffsetTransition:';
    function lineOffsetTransition: MGLTransition; message 'lineOffsetTransition';
    procedure setLineOpacity(newValue: MGLStyleValue); message 'setLineOpacity:';
    function lineOpacity: MGLStyleValue; message 'lineOpacity';
    procedure setLineOpacityTransition(newValue: MGLTransition); message 'setLineOpacityTransition:';
    function lineOpacityTransition: MGLTransition; message 'lineOpacityTransition';
    procedure setLinePattern(newValue: MGLStyleValue); message 'setLinePattern:';
    function linePattern: MGLStyleValue; message 'linePattern';
    procedure setLinePatternTransition(newValue: MGLTransition); message 'setLinePatternTransition:';
    function linePatternTransition: MGLTransition; message 'linePatternTransition';
    {$if defined(TARGET_OS_IPHONE)}
    procedure setLineTranslation(newValue: MGLStyleValue); message 'setLineTranslation:';
    function lineTranslation: MGLStyleValue; message 'lineTranslation';
    {$else}
    procedure setLineTranslation_(newValue: MGLStyleValue); message 'setLineTranslation:';
    function lineTranslation_: MGLStyleValue; message 'lineTranslation';
    {$endif}
    procedure setLineTranslationTransition(newValue: MGLTransition); message 'setLineTranslationTransition:';
    function lineTranslationTransition: MGLTransition; message 'lineTranslationTransition';
    procedure setLineTranslate(newValue: MGLStyleValue); message 'setLineTranslate:';
    function lineTranslate: MGLStyleValue; message 'lineTranslate';
    procedure setLineTranslationAnchor(newValue: MGLStyleValue); message 'setLineTranslationAnchor:';
    function lineTranslationAnchor: MGLStyleValue; message 'lineTranslationAnchor';
    procedure setLineTranslateAnchor(newValue: MGLStyleValue); message 'setLineTranslateAnchor:';
    function lineTranslateAnchor: MGLStyleValue; message 'lineTranslateAnchor';
    procedure setLineWidth(newValue: MGLStyleValue); message 'setLineWidth:';
    function lineWidth: MGLStyleValue; message 'lineWidth';
    procedure setLineWidthTransition(newValue: MGLTransition); message 'setLineWidthTransition:';
    function lineWidthTransition: MGLTransition; message 'lineWidthTransition';
  end;


type
  MGLLineStyleLayerAdditions = objccategory external (NSValue)
    class function valueWithMGLLineCap (lineCap: MGLLineCap): instancetype; message 'valueWithMGLLineCap:';
    function MGLLineCapValue: MGLLineCap; message 'MGLLineCapValue';
    class function valueWithMGLLineJoin (lineJoin: MGLLineJoin): instancetype; message 'valueWithMGLLineJoin:';
    function MGLLineJoinValue: MGLLineJoin; message 'MGLLineJoinValue';
    class function valueWithMGLLineTranslationAnchor (lineTranslationAnchor: MGLLineTranslationAnchor): instancetype; message 'valueWithMGLLineTranslationAnchor:';
    function MGLLineTranslationAnchorValue: MGLLineTranslationAnchor; message 'MGLLineTranslationAnchorValue';
  end;
{$endif}

