{ Parsed from Mapbox.framework MGLMapView.h }

{$ifdef TYPES}
type
  MGLMapViewPtr = ^MGLMapView;
{$endif}

{$ifdef CLASSES}

type
  MGLMapView = objcclass external (NSView)
  public
    function initWithFrame (frame_: NSRect): instancetype; message 'initWithFrame:';
    function initWithFrame_styleURL (frame_: NSRect; styleURL: NSURL): instancetype; message 'initWithFrame:styleURL:';
    procedure setDelegate(newValue: MGLMapViewDelegateProtocol); message 'setDelegate:';
    function delegate: MGLMapViewDelegateProtocol; message 'delegate';
    function style: MGLStyle; message 'style';
    procedure setStyleURL(newValue: NSURL); message 'setStyleURL:';
    function styleURL: NSURL; message 'styleURL';
    procedure reloadStyle (sender: id); message 'reloadStyle:';
    function zoomControls: NSSegmentedControl; message 'zoomControls';
    function compass: NSSlider; message 'compass';
    function logoView: NSImageView; message 'logoView';
    function attributionView: NSView; message 'attributionView';
    procedure setCenterCoordinate(newValue: CLLocationCoordinate2D); message 'setCenterCoordinate:';
    function centerCoordinate: CLLocationCoordinate2D; message 'centerCoordinate';
    procedure setCenterCoordinate_animated (coordinate: CLLocationCoordinate2D; animated: boolean); message 'setCenterCoordinate:animated:';
    procedure setZoomLevel(newValue: double); message 'setZoomLevel:';
    function zoomLevel: double; message 'zoomLevel';
    procedure setMinimumZoomLevel(newValue: double); message 'setMinimumZoomLevel:';
    function minimumZoomLevel: double; message 'minimumZoomLevel';
    procedure setMaximumZoomLevel(newValue: double); message 'setMaximumZoomLevel:';
    function maximumZoomLevel: double; message 'maximumZoomLevel';
    procedure setZoomLevel_animated (zoomLevel_: double; animated: boolean); message 'setZoomLevel:animated:';
    procedure setDirection(newValue: CLLocationDirection); message 'setDirection:';
    function direction: CLLocationDirection; message 'direction';
    procedure setDirection_animated (direction_: CLLocationDirection; animated: boolean); message 'setDirection:animated:';
    procedure setCamera(newValue: MGLMapCamera); message 'setCamera:';
    function camera: MGLMapCamera; message 'camera';
    procedure setCamera_animated (camera_: MGLMapCamera; animated: boolean); message 'setCamera:animated:';
    procedure setCamera_withDuration_animationTimingFunction_completionHandler (camera_: MGLMapCamera; duration: NSTimeInterval; function_: CAMediaTimingFunction; completion: OpaqueCBlock); message 'setCamera:withDuration:animationTimingFunction:completionHandler:';
    procedure setCamera_withDuration_animationTimingFunction_edgePadding_completionHandler (camera_: MGLMapCamera; duration: NSTimeInterval; function_: CAMediaTimingFunction; edgePadding: NSEdgeInsets; completion: OpaqueCBlock); message 'setCamera:withDuration:animationTimingFunction:edgePadding:completionHandler:';
    procedure flyToCamera_completionHandler (camera_: MGLMapCamera; completion: OpaqueCBlock); message 'flyToCamera:completionHandler:';
    procedure flyToCamera_withDuration_completionHandler (camera_: MGLMapCamera; duration: NSTimeInterval; completion: OpaqueCBlock); message 'flyToCamera:withDuration:completionHandler:';
    procedure flyToCamera_withDuration_peakAltitude_completionHandler (camera_: MGLMapCamera; duration: NSTimeInterval; peakAltitude: CLLocationDistance; completion: OpaqueCBlock); message 'flyToCamera:withDuration:peakAltitude:completionHandler:';
    procedure setVisibleCoordinateBounds(newValue: MGLCoordinateBounds); message 'setVisibleCoordinateBounds:';
    function visibleCoordinateBounds: MGLCoordinateBounds; message 'visibleCoordinateBounds';
    procedure setVisibleCoordinateBounds_animated (bounds_: MGLCoordinateBounds; animated: boolean); message 'setVisibleCoordinateBounds:animated:';
    procedure setVisibleCoordinateBounds_edgePadding_animated (bounds_: MGLCoordinateBounds; insets: NSEdgeInsets; animated: boolean); message 'setVisibleCoordinateBounds:edgePadding:animated:';
    procedure showAnnotations_animated (annotations: NSArray; animated: boolean); message 'showAnnotations:animated:';
    procedure showAnnotations_edgePadding_animated (annotations: NSArray; insets: NSEdgeInsets; animated: boolean); message 'showAnnotations:edgePadding:animated:';
    function cameraThatFitsCoordinateBounds (bounds_: MGLCoordinateBounds): MGLMapCamera; message 'cameraThatFitsCoordinateBounds:';
    function cameraThatFitsCoordinateBounds_edgePadding (bounds_: MGLCoordinateBounds; insets: NSEdgeInsets): MGLMapCamera; message 'cameraThatFitsCoordinateBounds:edgePadding:';
    function cameraThatFitsShape_direction_edgePadding (shape: MGLShape; direction_: CLLocationDirection; insets: NSEdgeInsets): MGLMapCamera; message 'cameraThatFitsShape:direction:edgePadding:';
    procedure setAutomaticallyAdjustsContentInsets(newValue: boolean); message 'setAutomaticallyAdjustsContentInsets:';
    function automaticallyAdjustsContentInsets: boolean; message 'automaticallyAdjustsContentInsets';
    procedure setContentInsets(newValue: NSEdgeInsets); message 'setContentInsets:';
    function contentInsets: NSEdgeInsets; message 'contentInsets';
    procedure setContentInsets_animated (contentInsets_: NSEdgeInsets; animated: boolean); message 'setContentInsets:animated:';
    procedure setZoomEnabled(newValue: boolean); message 'setZoomEnabled:';
    function isZoomEnabled: boolean; message 'isZoomEnabled';
    procedure setScrollEnabled(newValue: boolean); message 'setScrollEnabled:';
    function isScrollEnabled: boolean; message 'isScrollEnabled';
    procedure setRotateEnabled(newValue: boolean); message 'setRotateEnabled:';
    function isRotateEnabled: boolean; message 'isRotateEnabled';
    procedure setPitchEnabled(newValue: boolean); message 'setPitchEnabled:';
    function isPitchEnabled: boolean; message 'isPitchEnabled';
    function annotations: NSArray; message 'annotations';
    procedure addAnnotation (annotation: MGLAnnotationProtocol); message 'addAnnotation:';
    procedure addAnnotations (annotations_: NSArray); message 'addAnnotations:';
    function visibleAnnotations: NSArray; message 'visibleAnnotations';
    procedure removeAnnotation (annotation: MGLAnnotationProtocol); message 'removeAnnotation:';
    procedure removeAnnotations (annotations_: NSArray); message 'removeAnnotations:';
    function dequeueReusableAnnotationImageWithIdentifier (identifier: NSString): MGLAnnotationImage; message 'dequeueReusableAnnotationImageWithIdentifier:';
    function visibleAnnotationsInRect (rect: CGRect): NSArray; message 'visibleAnnotationsInRect:';
    procedure setSelectedAnnotations(newValue: NSArray); message 'setSelectedAnnotations:';
    function selectedAnnotations: NSArray; message 'selectedAnnotations';
    procedure selectAnnotation (annotation: MGLAnnotationProtocol); message 'selectAnnotation:';
    procedure deselectAnnotation (annotation: MGLAnnotationProtocol); message 'deselectAnnotation:';
    procedure setCalloutViewController(newValue: NSViewController); message 'setCalloutViewController:';
    function calloutViewController: NSViewController; message 'calloutViewController';
    function annotationAtPoint (point: NSPoint): MGLAnnotationProtocol; message 'annotationAtPoint:';
    function overlays: NSArray; message 'overlays';
    procedure addOverlay (overlay: MGLOverlayProtocol); message 'addOverlay:';
    procedure addOverlays (overlays_: NSArray); message 'addOverlays:';
    procedure removeOverlay (overlay: MGLOverlayProtocol); message 'removeOverlay:';
    procedure removeOverlays (overlays_: NSArray); message 'removeOverlays:';
    function visibleFeaturesAtPoint (point: NSPoint): NSArray; message 'visibleFeaturesAtPoint:';
    function visibleFeaturesAtPoint_inStyleLayersWithIdentifiers_at (point: NSPoint; styleLayerIdentifiers: NSSet; styleLayerIdentifiers3: id): NSArray; message 'visibleFeaturesAtPoint:inStyleLayersWithIdentifiers:at:';
    function visibleFeaturesAtPoint_inStyleLayersWithIdentifiers_predicate_at (point: NSPoint; styleLayerIdentifiers: NSSet; predicate: NSPredicate; styleLayerIdentifiers4: id): NSArray; message 'visibleFeaturesAtPoint:inStyleLayersWithIdentifiers:predicate:at:';
    function visibleFeaturesInRect (rect: NSRect): NSArray; message 'visibleFeaturesInRect:';
    function visibleFeaturesInRect_inStyleLayersWithIdentifiers_at (rect: NSRect; styleLayerIdentifiers: NSSet; styleLayerIdentifiers3: id): NSArray; message 'visibleFeaturesInRect:inStyleLayersWithIdentifiers:at:';
    function visibleFeaturesInRect_inStyleLayersWithIdentifiers_predicate_in (rect: NSRect; styleLayerIdentifiers: NSSet; predicate: NSPredicate; styleLayerIdentifiers4: id): NSArray; message 'visibleFeaturesInRect:inStyleLayersWithIdentifiers:predicate:in:';
    function convertCoordinate_toPointToView (coordinate: CLLocationCoordinate2D; view: NSView): NSPoint; message 'convertCoordinate:toPointToView:';
    function convertPoint_toCoordinateFromView (point: NSPoint; view: NSView): CLLocationCoordinate2D; message 'convertPoint:toCoordinateFromView:';
    function convertCoordinateBounds_toRectToView (bounds_: MGLCoordinateBounds; view: NSView): NSRect; message 'convertCoordinateBounds:toRectToView:';
    function convertRect_toCoordinateBoundsFromView (rect: NSRect; view: NSView): MGLCoordinateBounds; message 'convertRect:toCoordinateBoundsFromView:';
    function metersPerPointAtLatitude (latitude: CLLocationDegrees): CLLocationDistance; message 'metersPerPointAtLatitude:';
    procedure giveFeedback (sender: id); message 'giveFeedback:';
    procedure setDebugMask(newValue: MGLMapDebugMaskOptions); message 'setDebugMask:';
    function debugMask: MGLMapDebugMaskOptions; message 'debugMask';
  end;
{$endif}

