{ Parsed from Mapbox.framework MGLOfflineStorage.h }

{$ifdef TYPES}
type
  MGLOfflineStoragePtr = ^MGLOfflineStorage;
  MGLOfflineStorageDelegateProtocolPtr = ^MGLOfflineStorageDelegateProtocol;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  MGLOfflinePackProgressChangedNotification: NSNotificationName; cvar; external;
  MGLOfflinePackErrorNotification: NSNotificationName; cvar; external;
  MGLOfflinePackMaximumMapboxTilesReachedNotification: NSNotificationName; cvar; external;
{$endif}

{$ifdef TYPES}
type
  MGLOfflinePackUserInfoKey = ^NSString;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  MGLOfflinePackUserInfoKeyState: MGLOfflinePackUserInfoKey; cvar; external;
  MGLOfflinePackStateUserInfoKey: NSString; cvar; external;
  MGLOfflinePackUserInfoKeyProgress: MGLOfflinePackUserInfoKey; cvar; external;
  MGLOfflinePackProgressUserInfoKey: NSString; cvar; external;
  MGLOfflinePackUserInfoKeyError: MGLOfflinePackUserInfoKey; cvar; external;
  MGLOfflinePackErrorUserInfoKey: NSString; cvar; external;
  MGLOfflinePackUserInfoKeyMaximumCount: MGLOfflinePackUserInfoKey; cvar; external;
  MGLOfflinePackMaximumCountUserInfoKey: NSString; cvar; external;
{$endif}

{$ifdef TYPES}
type
  MGLOfflinePackAdditionCompletionHandler = OpaqueCBlock;
  MGLOfflinePackRemovalCompletionHandler = OpaqueCBlock;
  MGLResourceKind = NSUInteger;
  MGLResourceKindPtr = ^MGLResourceKind;

const
  MGLResourceKindUnknown = 0;
  MGLResourceKindStyle = 1;
  MGLResourceKindSource = 2;
  MGLResourceKindTile = 3;
  MGLResourceKindGlyphs = 4;
  MGLResourceKindSpriteImage = 5;
  MGLResourceKindSpriteJSON = 6;
  MGLResourceKindImage = 7;
{$endif}

{$ifdef CLASSES}

type
  MGLOfflineStorage = objcclass external (NSObject)
  public
    class function sharedOfflineStorage: instancetype; message 'sharedOfflineStorage';
    procedure setDelegate(newValue: MGLOfflineStorageDelegateProtocol); message 'setDelegate:';
    function delegate: MGLOfflineStorageDelegateProtocol; message 'delegate';
    function packs: NSArray; message 'packs';
    procedure addPackForRegion_withContext_completionHandler (region: MGLOfflineRegionProtocol; context: NSData; completion: MGLOfflinePackAdditionCompletionHandler); message 'addPackForRegion:withContext:completionHandler:';
    procedure removePack_withCompletionHandler (pack: MGLOfflinePack; completion: MGLOfflinePackRemovalCompletionHandler); message 'removePack:withCompletionHandler:';
    procedure reloadPacks; message 'reloadPacks';
    procedure setMaximumAllowedMapboxTiles (maximumCount: cuint64); message 'setMaximumAllowedMapboxTiles:';
    function countOfBytesCompleted: culonglong; message 'countOfBytesCompleted';
  end;
{$endif}

{$ifdef PROTOCOLS}

type
  MGLOfflineStorageDelegateProtocol = objcprotocol external name 'MGLOfflineStorageDelegate' (NSObjectProtocol)
    function offlineStorage_URLForResourceOfKind_withURL (storage: MGLOfflineStorage; kind: MGLResourceKind; url: NSURL): NSURL; message 'offlineStorage:URLForResourceOfKind:withURL:';
  end;
{$endif}

