{ Parsed from Mapbox.framework MGLStyle.h }

{$ifdef TYPES}
type
  MGLStylePtr = ^MGLStyle;
{$endif}

{$ifdef CLASSES}

type
  MGLStyle = objcclass external (NSObject)
  public
    class function streetsStyleURL: NSURL; message 'streetsStyleURL';
    class function streetsStyleURLWithVersion (version: NSInteger): NSURL; message 'streetsStyleURLWithVersion:';
//    class function emeraldStyleURL __attribute__((deprecated("Create an NSURL object with the string “mapbox:
//+ (NSURL *)outdoorsStyleURL: NSURL; message 'emeraldStyleURL __attribute__((deprecated("Create an NSURL object with the string “mapbox:
//+ (NSURL *)outdoorsStyleURL';
    class function emeraldStyleURL: NSURL; message 'emeraldStyleURL';
    class function outdoorsStyleURLWithVersion (version: NSInteger): NSURL; message 'outdoorsStyleURLWithVersion:';
    class function lightStyleURL: NSURL; message 'lightStyleURL';
    class function lightStyleURLWithVersion (version: NSInteger): NSURL; message 'lightStyleURLWithVersion:';
    class function darkStyleURL: NSURL; message 'darkStyleURL';
    class function darkStyleURLWithVersion (version: NSInteger): NSURL; message 'darkStyleURLWithVersion:';
    class function satelliteStyleURL: NSURL; message 'satelliteStyleURL';
    class function satelliteStyleURLWithVersion (version: NSInteger): NSURL; message 'satelliteStyleURLWithVersion:';
    class function hybridStyleURL: NSURL; message 'hybridStyleURL';
    class function satelliteStreetsStyleURL: NSURL; message 'satelliteStreetsStyleURL';
    class function satelliteStreetsStyleURLWithVersion (version: NSInteger): NSURL; message 'satelliteStreetsStyleURLWithVersion:';
    class function trafficDayStyleURLWithVersion_trafficNightStyleURLWithVersion (version: NSInteger; version2: NSInteger): NSURL; message 'trafficDayStyleURLWithVersion:trafficNightStyleURLWithVersion:';
    procedure setSources(newValue: NSSet); message 'setSources:';
    function sources: NSSet; message 'sources';
    procedure setTransition(newValue: MGLTransition); message 'setTransition:';
    function transition: MGLTransition; message 'transition';
    function sourceWithIdentifier (identifier: NSString): MGLSource; message 'sourceWithIdentifier:';
    procedure addSource (source: MGLSource); message 'addSource:';
    procedure removeSource (source: MGLSource); message 'removeSource:';
    procedure setLayers(newValue: NSArray); message 'setLayers:';
    function layers: NSArray; message 'layers';
    function layerWithIdentifier (identifier: NSString): MGLStyleLayer; message 'layerWithIdentifier:';
    procedure addLayer (layer: MGLStyleLayer); message 'addLayer:';
    procedure insertLayer_atIndex (layer: MGLStyleLayer; index: NSUInteger); message 'insertLayer:atIndex:';
    procedure insertLayer_belowLayer (layer: MGLStyleLayer; sibling: MGLStyleLayer); message 'insertLayer:belowLayer:';
    procedure insertLayer_aboveLayer (layer: MGLStyleLayer; sibling: MGLStyleLayer); message 'insertLayer:aboveLayer:';
    procedure removeLayer (layer: MGLStyleLayer); message 'removeLayer:';
    procedure setStyleClasses(newValue: NSArray); message 'setStyleClasses:';
    function styleClasses: NSArray; message 'styleClasses';
    function hasStyleClass (styleClass: NSString): boolean; message 'hasStyleClass:';
    procedure addStyleClass (styleClass: NSString); message 'addStyleClass:';
    procedure removeStyleClass (styleClass: NSString); message 'removeStyleClass:';
    function imageForName (name: NSString): MGLImage; message 'imageForName:';
    procedure setImage_forName (image: MGLImage; name: NSString); message 'setImage:forName:';
    procedure removeImageForName (name: NSString); message 'removeImageForName:';
    procedure setLight(newValue: MGLLight); message 'setLight:';
    function light: MGLLight; message 'light';
    procedure setLocalizesLabels(newValue: boolean); message 'setLocalizesLabels:';
    function localizesLabels: boolean; message 'localizesLabels';
  end;
{$endif}

