{ Parsed from Mapbox.framework MGLStyleValue.h }

{$ifdef TYPES}
type
  MGLStyleValuePtr = ^MGLStyleValue;
  MGLConstantStyleValuePtr = ^MGLConstantStyleValue;
  MGLStyleFunctionPtr = ^MGLStyleFunction;
  MGLCameraStyleFunctionPtr = ^MGLCameraStyleFunction;
  MGLSourceStyleFunctionPtr = ^MGLSourceStyleFunction;
  MGLCompositeStyleFunctionPtr = ^MGLCompositeStyleFunction;
{$endif}

{$ifdef TYPES}
type
  MGLStyleFunctionOption = ^NSString;
{$endif}

{$ifdef EXTERNAL_SYMBOLS}
var
  MGLStyleFunctionOptionInterpolationBase: MGLStyleFunctionOption; cvar; external;
  MGLStyleFunctionOptionDefaultValue: MGLStyleFunctionOption; cvar; external;
{$endif}

{$ifdef TYPES}
type
  MGLInterpolationMode = NSUInteger;
  MGLInterpolationModePtr = ^MGLInterpolationMode;

const
  MGLInterpolationModeExponential = 0;
  MGLInterpolationModeInterval = 1;
  MGLInterpolationModeCategorical = 2;
  MGLInterpolationModeIdentity = 3;
{$endif}

{$ifdef CLASSES}

type
  MGLStyleValue = objcclass external (NSObject)
  public
    class function valueWithRawValue (rawValue: id): instancetype; message 'valueWithRawValue:';
//    class function valueWithRawValue (rawValue: T): instancetype; message 'valueWithRawValue:';
    class function valueWithStops (stops: NSDictionary): instancetype; message 'valueWithStops:';
    class function valueWithInterpolationBase_stops (interpolationBase: CGFloat; stops: NSDictionary): instancetype; message 'valueWithInterpolationBase:stops:';
    class function valueWithInterpolationMode_cameraStops_options (interpolationMode: MGLInterpolationMode; cameraStops: NSDictionary; options: NSDictionary): instancetype; message 'valueWithInterpolationMode:cameraStops:options:';
    class function valueWithInterpolationMode_sourceStops_attributeName_options (interpolationMode: MGLInterpolationMode; sourceStops: NSDictionary; attributeName: NSString; options: NSDictionary): instancetype; message 'valueWithInterpolationMode:sourceStops:attributeName:options:';
//    class function valueWithInterpolationMode_compositeStops_attributeName_options (interpolationMode: MGLInterpolationMode; compositeStops: NSDictionary *)Ptr; attributeName: NSString; options: NSDictionary): instancetype; message 'valueWithInterpolationMode:compositeStops:attributeName:options:';
    class function valueWithInterpolationMode_compositeStops_attributeName_options (interpolationMode: MGLInterpolationMode; compositeStops: NSDictionary; attributeName: NSString; options: NSDictionary): instancetype; message 'valueWithInterpolationMode:compositeStops:attributeName:options:';
  end;

type
  MGLConstantStyleValue = objcclass external (MGLStyleValue)
  public
    class function valueWithRawValue (rawValue: id): instancetype; message 'valueWithRawValue:';
    function init: instancetype; message 'init';
    function initWithRawValue (rawValue: id): instancetype; message 'initWithRawValue:'; { NS_DESIGNATED_INITIALIZER }
    procedure setRawValue(newValue: id); message 'setRawValue:';
    function rawValue: id; message 'rawValue';
//    class function valueWithRawValue (rawValue: T): instancetype; message 'valueWithRawValue:';
//    function init: instancetype; message 'init';
//    function initWithRawValue (rawValue: T): instancetype; message 'initWithRawValue:'; { NS_DESIGNATED_INITIALIZER }
//    procedure setRawValue(newValue: T); message 'setRawValue:';
//    function rawValue: T; message 'rawValue';
  end;

type
  MGLStyleFunction = objcclass external (MGLStyleValue)
  public
    class function functionWithStops (stops: NSDictionary): instancetype; message 'functionWithStops:';
    class function functionWithInterpolationBase_stops (interpolationBase: CGFloat; stops: NSDictionary): instancetype; message 'functionWithInterpolationBase:stops:';
    function initWithInterpolationBase_stops (interpolationBase: CGFloat; stops: NSDictionary): instancetype; message 'initWithInterpolationBase:stops:';
    procedure setInterpolationMode(newValue: MGLInterpolationMode); message 'setInterpolationMode:';
    function interpolationMode: MGLInterpolationMode; message 'interpolationMode';
    procedure setStops(newValue: NSDictionary); message 'setStops:';
    function stops: NSDictionary; message 'stops';
    procedure setInterpolationBase(newValue: CGFloat); message 'setInterpolationBase:';
    function interpolationBase: CGFloat; message 'interpolationBase';
  end;

type
  MGLCameraStyleFunction = objcclass external (MGLStyleFunction)
  public
    class function functionWithInterpolationMode_stops_options (interpolationMode_: MGLInterpolationMode; stops_: NSDictionary; options: NSDictionary): instancetype; message 'functionWithInterpolationMode:stops:options:';
    procedure setStops(newValue: NSDictionary); message 'setStops:';
    function stops: NSDictionary; message 'stops';
  end;

type
  MGLSourceStyleFunction = objcclass external (MGLStyleFunction)
  public
    class function functionWithInterpolationMode_stops_attributeName_options (interpolationMode_: MGLInterpolationMode; stops_: NSDictionary; attributeName: NSString; options: NSDictionary): instancetype; message 'functionWithInterpolationMode:stops:attributeName:options:';
    procedure setAttributeName(newValue: NSString); message 'setAttributeName:';
    function attributeName: NSString; message 'attributeName';
    procedure setStops(newValue: NSDictionary); message 'setStops:';
    function stops: NSDictionary; message 'stops';
    procedure setDefaultValue(newValue: MGLStyleValue); message 'setDefaultValue:';
    function defaultValue: MGLStyleValue; message 'defaultValue';
  end;

type
  MGLCompositeStyleFunction = objcclass external (MGLStyleFunction)
  public
//    class function functionWithInterpolationMode_stops_attributeName_options (interpolationMode_: MGLInterpolationMode; stops_: NSDictionary *)Ptr; attributeName: NSString; options: NSDictionary): instancetype; message 'functionWithInterpolationMode:stops:attributeName:options:';
    class function functionWithInterpolationMode_stops_attributeName_options (interpolationMode: MGLInterpolationMode; stops: NSDictionary; attributeName: NSString; options: NSDictionary): instancetype; message 'functionWithInterpolationMode:stops:attributeName:options:';
    procedure setAttributeName(newValue: NSString); message 'setAttributeName:';
    function attributeName: NSString; message 'attributeName';
//    procedure setStops(newValue: NSDictionary *)Ptr); message 'setStops:';
    procedure setStops(newValue: NSDictionary); message 'setStops:';
//    function stops: NSDictionary *)Ptr; message 'stops';
    function stops: NSDictionary; message 'stops';
    procedure setDefaultValue(newValue: MGLStyleValue); message 'setDefaultValue:';
    function defaultValue: MGLStyleValue; message 'defaultValue';
  end;
{$endif}

