unit Mapbox_Ctrls_Factory;

{
  LCL Mapbox map control.

  Author:    Phil Hess.
  Copyright: Copyright (C) Phil Hess.
  License:   Modified LGPL (see Free Pascal's rtl/COPYING.FPC).
}

{$mode objfpc}{$H+}

interface

uses
  WSLCLClasses,
  MbMap,
{$IF DEFINED(LCLCocoa) AND DEFINED(CPU64)}
  CocoaMbMap;
{$ELSE}
  WSMbMap;  //for now until other platforms implemented
{$ENDIF}

function RegisterMbMap : Boolean;

function GetMbVersionNumber : Double;

procedure SetMbAccessToken(const AAccessToken : string);


implementation

function RegisterMbMap : Boolean; alias : 'WSRegisterMbMap';
begin
  Result := True;
{$IF DEFINED(LCLCocoa) AND DEFINED(CPU64)}
  RegisterWSComponent(TCustomMbMap, TCocoaWSMbMap);
{$ELSE}
  RegisterWSComponent(TCustomMbMap, TWSMbMap);
{$ENDIF}
end;


function GetMbVersionNumber : Double;
begin
{$IF DEFINED(LCLCocoa) AND DEFINED(CPU64)}
  Result := TCocoaWSMbMap.GetVersionNumber;
{$ELSE}
  Result := TWSMbMap.GetVersionNumber;
{$ENDIF}
end;


procedure SetMbAccessToken(const AAccessToken : string);
begin
{$IF DEFINED(LCLCocoa) AND DEFINED(CPU64)}
  TCocoaWSMbMap.SetAccessToken(AAccessToken);
{$ELSE}
  TWSMbMap.SetAccessToken(AAccessToken);
{$ENDIF}
end;


initialization

end.
