unit WSMbMap;

{
  LCL Mapbox map control.

  Author:    Phil Hess.
  Copyright: Copyright (C) Phil Hess.
  License:   Modified LGPL (see Free Pascal's rtl/COPYING.FPC).
}

{$mode objfpc}{$H+}

interface

uses
  WSControls,
  Controls;

type
  TWSMbMap = class(TWSWinControl)
  published
    class function GetVersionNumber : Double;
    class procedure SetAccessToken(const AAccessToken : string); virtual;
    class procedure AddPointAnnotation(const AWinControl  : TWinControl;
                                             ALatitude    : Double;
                                             ALongitude   : Double;
                                       const ATitle       : string;
                                       const ASubtitle    : string); virtual;
    class procedure GiveFeedback(const AWinControl : TWinControl); virtual;
    class function GetStyleURL(const AWinControl : TWinControl;
                                 var AStyleURL   : string): Boolean; virtual;
    class procedure SetStyleURL(const AWinControl : TWinControl;
                                const AStyleURL   : string); virtual;
    class function GetLatitude(const AWinControl : TWinControl;
                                 var ALatitude   : Double): Boolean; virtual;
    class procedure SetLatitude(const AWinControl : TWinControl;
                                      ALatitude  : Double); virtual;
    class function GetLongitude(const AWinControl : TWinControl;
                                  var ALongitude   : Double): Boolean; virtual;
    class procedure SetLongitude(const AWinControl : TWinControl;
                                       ALongitude  : Double); virtual;
    class function GetZoomLevel(const AWinControl : TWinControl;
                                  var AZoomLevel  : Double): Boolean; virtual;
    class procedure SetZoomLevel(const AWinControl : TWinControl;
                                       AZoomLevel  : Double); virtual;
    class function GetDirection(const AWinControl : TWinControl;
                                  var ADirection  : Double): Boolean; virtual;
    class procedure SetDirection(const AWinControl : TWinControl;
                                       ADirection  : Double); virtual;
    class function GetAllowZoom(const AWinControl : TWinControl;
                                  var AAllowZoom  : Boolean): Boolean; virtual;
    class procedure SetAllowZoom(const AWinControl : TWinControl;
                                       AAllowZoom  : Boolean); virtual;
    class function GetAllowScroll(const AWinControl  : TWinControl;
                                    var AAllowScroll : Boolean): Boolean; virtual;
    class procedure SetAllowScroll(const AWinControl  : TWinControl;
                                         AAllowScroll : Boolean); virtual;
    class function GetAllowRotate(const AWinControl  : TWinControl;
                                    var AAllowRotate : Boolean): Boolean; virtual;
    class procedure SetAllowRotate(const AWinControl  : TWinControl;
                                         AAllowRotate : Boolean); virtual;
    class function GetAllowTilt(const AWinControl : TWinControl;
                                  var AAllowTilt  : Boolean): Boolean; virtual;
    class procedure SetAllowTilt(const AWinControl : TWinControl;
                                       AAllowTilt  : Boolean); virtual;
    class function GetShowZoomControls(const AWinControl        : TWinControl;
                                         var AShowZoomControls  : Boolean): Boolean; virtual;
    class procedure SetShowZoomControls(const AWinControl       : TWinControl;
                                              AShowZoomControls : Boolean); virtual;
    class function GetShowCompass(const AWinControl  : TWinControl;
                                    var AShowCompass : Boolean): Boolean; virtual;
    class procedure SetShowCompass(const AWinControl  : TWinControl;
                                         AShowCompass : Boolean); virtual;
    class procedure SetEnableClickMap(const AWinControl     : TWinControl;
                                            AEnableClickMap : Boolean); virtual;
    class procedure SetEnableDblClickMap(const AWinControl        : TWinControl;
                                               AEnableDblClickMap : Boolean); virtual;
    class procedure SetEnableRightClickMap(const AWinControl          : TWinControl;
                                                 AEnableRightClickMap : Boolean); virtual;
  end;

  TWSMbMapClass = class of TWSMbMap;

function WSRegisterMbMap : Boolean; external name 'WSRegisterMbMap';


implementation

class function TWSMbMap.GetVersionNumber : Double;
begin
  Result := 0;
end;


class procedure TWSMbMap.SetAccessToken(const AAccessToken : string);
begin
end;


class procedure TWSMbMap.AddPointAnnotation(const AWinControl  : TWinControl;
                                                  ALatitude    : Double;
                                                  ALongitude   : Double;
                                            const ATitle       : string;
                                            const ASubtitle    : string);
begin
end;


class procedure TWSMbMap.GiveFeedback(const AWinControl : TWinControl);
begin
end;


class function TWSMbMap.GetStyleURL(const AWinControl : TWinControl; 
                                      var AStyleURL   : string): Boolean;
begin
  Result := False;
end;


class procedure TWSMbMap.SetStyleURL(const AWinControl : TWinControl;
                                     const AStyleURL   : string);
begin
end;


class function TWSMbMap.GetLatitude(const AWinControl : TWinControl; 
                                      var ALatitude   : Double): Boolean;
begin
  Result := False;
end;


class procedure TWSMbMap.SetLatitude(const AWinControl : TWinControl;
                                           ALatitude   : Double);
begin
end;


class function TWSMbMap.GetLongitude(const AWinControl : TWinControl; 
                                       var ALongitude   : Double): Boolean;
begin
  Result := False;
end;


class procedure TWSMbMap.SetLongitude(const AWinControl : TWinControl;
                                            ALongitude   : Double);
begin
end;


class function TWSMbMap.GetZoomLevel(const AWinControl : TWinControl; 
                                       var AZoomLevel  : Double): Boolean;
begin
  Result := False;
end;


class procedure TWSMbMap.SetZoomLevel(const AWinControl : TWinControl;
                                            AZoomLevel  : Double);
begin
end;


class function TWSMbMap.GetDirection(const AWinControl : TWinControl; 
                                       var ADirection  : Double): Boolean;
begin
  Result := False;
end;


class procedure TWSMbMap.SetDirection(const AWinControl : TWinControl;
                                            ADirection  : Double);
begin
end;


class function TWSMbMap.GetAllowZoom(const AWinControl : TWinControl; 
                                       var AAllowZoom  : Boolean): Boolean;
begin
  Result := False;
end;


class procedure TWSMbMap.SetAllowZoom(const AWinControl : TWinControl;
                                            AAllowZoom  : Boolean);
begin
end;


class function TWSMbMap.GetAllowScroll(const AWinControl  : TWinControl; 
                                         var AAllowScroll : Boolean): Boolean;
begin
  Result := False;
end;


class procedure TWSMbMap.SetAllowScroll(const AWinControl  : TWinControl;
                                              AAllowScroll : Boolean);
begin
end;


class function TWSMbMap.GetAllowRotate(const AWinControl  : TWinControl; 
                                         var AAllowRotate : Boolean): Boolean;
begin
  Result := False;
end;


class procedure TWSMbMap.SetAllowRotate(const AWinControl  : TWinControl;
                                              AAllowRotate : Boolean);
begin
end;


class function TWSMbMap.GetAllowTilt(const AWinControl : TWinControl; 
                                       var AAllowTilt  : Boolean): Boolean;
begin
  Result := False;
end;


class procedure TWSMbMap.SetAllowTilt(const AWinControl : TWinControl;
                                            AAllowTilt  : Boolean);
begin
end;


class function TWSMbMap.GetShowZoomControls(const AWinControl       : TWinControl; 
                                              var AShowZoomControls : Boolean): Boolean;
begin
  Result := False;
end;


class procedure TWSMbMap.SetShowZoomControls(const AWinControl       : TWinControl;
                                                   AShowZoomControls : Boolean);
begin
end;


class function TWSMbMap.GetShowCompass(const AWinControl  : TWinControl; 
                                         var AShowCompass : Boolean): Boolean;
begin
  Result := False;
end;


class procedure TWSMbMap.SetShowCompass(const AWinControl  : TWinControl;
                                              AShowCompass : Boolean);
begin
end;


class procedure TWSMbMap.SetEnableClickMap(const AWinControl     : TWinControl;
                                                 AEnableClickMap : Boolean);
begin
end;


class procedure TWSMbMap.SetEnableDblClickMap(const AWinControl        : TWinControl;
                                                    AEnableDblClickMap : Boolean);
begin
end;


class procedure TWSMbMap.SetEnableRightClickMap(const AWinControl          : TWinControl;
                                                      AEnableRightClickMap : Boolean);
begin
end;


end.
